Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1515357 - Obsoleting platform-python-libs-3.6.2-12.fc28 with python3-libs-3.6.3-3.fc28.x86_64 accompanied with %postun non-fatal failure
Summary: Obsoleting platform-python-libs-3.6.2-12.fc28 with python3-libs-3.6.3-3.fc28....
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: platform-python
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Miro Hrončok
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-11-20 16:34 UTC by Jan Pokorný [poki]
Modified: 2017-12-10 05:05 UTC (History)
5 users (show)

Fixed In Version: platform-python-3.6.2-13.fc27
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-12-10 05:05:11 UTC


Attachments (Terms of Use)

Description Jan Pokorný [poki] 2017-11-20 16:34:18 UTC
Just happened to me when updating rawhide installation:

> [...]
> Packages Altered:
> [...]
>     Obsoleted  platform-python-3.6.2-12.fc28.x86_64                          @rawhide
>     Obsoleted  platform-python-libs-3.6.2-12.fc28.x86_64                     @rawhide
>     Obsoleted  platform-python-six-1.11.0-1.fc28.noarch                      @rawhide
> [...]
>     Upgraded   python3-libs-3.6.3-2.fc28.x86_64                              @rawhide
>     Upgrade                 3.6.3-3.fc28.x86_64                              @rawhide
>     Obsoleting python3-libs-3.6.3-3.fc28.x86_64                              @rawhide
> [...]
> 
> Scriptlet output:
> [...]
>    3 warning: %postun(platform-python-libs-3.6.2-12.fc28.x86_64) scriptlet failed, exit status 1
> [...]

I believe it is a reasonable expectation that such manoeuvres should
be smooth.


Moreover, I lack any kind of reference (a bug/ticket, feature proposal,
or python-devel fedora ML) for why platform-python idea has been abandoned
beside commits themselves:
  https://src.fedoraproject.org/rpms/platform-python/c/a0b3f367397037ab1420e4035c7ec79955cb096d?branch=master
  https://src.fedoraproject.org/rpms/python3/c/e522c84bc535b0c34ede8361d245205842f80dca?branch=master
(e.g., no mention at https://fedoraproject.org/wiki/Releases/28/ChangeSet)
while it was only in Fedora 27 where the Platform Python Stack was
introduced:
https://fedoraproject.org/wiki/Releases/27/ChangeSet#Platform_Python_Stack)

Comment 1 Jan Pokorný [poki] 2017-11-20 17:44:05 UTC
The output above obtained with "dnf history info" command
(that it isn't too clear on obsoleting performed is filed
as [bug 1515386]).

Comment 2 Miro Hrončok 2017-11-21 08:47:51 UTC
(In reply to Jan Pokorný from comment #0)
> I believe it is a reasonable expectation that such manoeuvres should
> be smooth.

I agree.


> Moreover, I lack any kind of reference (a bug/ticket, feature proposal,
> or python-devel fedora ML) for why platform-python idea has been abandoned
> beside commits themselves:
>  
> https://src.fedoraproject.org/rpms/platform-python/c/
> a0b3f367397037ab1420e4035c7ec79955cb096d?branch=master
>  
> https://src.fedoraproject.org/rpms/python3/c/
> e522c84bc535b0c34ede8361d245205842f80dca?branch=master
> (e.g., no mention at https://fedoraproject.org/wiki/Releases/28/ChangeSet)
> while it was only in Fedora 27 where the Platform Python Stack was
> introduced:
> https://fedoraproject.org/wiki/Releases/27/ChangeSet#Platform_Python_Stack)

There is no reference. One day I've realized the platform-python subpackages were removed from Fedora. I've asked Igor (CCed), who have done it, and he said that the modularity team have never used Platform Python at all and that they don't need it, so he went on and removed the subpackages in rawhide (keeping them unused in f27). So I went and removed the platform-python package itself from rawhide as well. I haven't realized that removing a single package from rawhide (where nothing depends on it anymore), needs a reference. Sorry about that. I was a bit disgruntled when I was doing it, maybe mu judgement was a bit cluttered ATM. What do you think would be the best reference? Should I post an email to devel? Create a Fedora change proposal?


Back to the topic: Thanks for the report. I don't understand from the output what's went wrong with the platform-python-libs postun scriptlet and how is obsoleting it relevant. Any ideas? If you obtain the package (from let's say Koji), install and uninstall it again, does the postun error happen anyway, or is it only happening when the obsolete thing happens? Is it possible that the postun scriplet is somehow broken on platform-python-libs (which is now removed) and we are unable to fix it now anyway?

Comment 3 Miro Hrončok 2017-11-21 08:52:11 UTC
$ rpm -q --scripts -p Stažené/platform-python-libs-3.6.2-12.fc28.x86_64.rpm 
postinstall program: /sbin/ldconfig
postuninstall scriptlet (using /sbin/ldconfig):

# ======================================================
# Files
# ======================================================

Comment 4 Miro Hrončok 2017-11-21 08:54:53 UTC
Apparently, the comment that comes after this cannot be there:

https://src.fedoraproject.org/rpms/platform-python/blob/f27/f/platform-python.spec#_948


# ======================================================
# Scriptlets
# ======================================================

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

# ======================================================
# Files
# ======================================================

%files

Comment 5 Miro Hrončok 2017-11-21 08:58:15 UTC
Now I can certainly fix this oversight in Fedora 27 and doing an platform-python-3.6.2-13.fc27 update and bumping the obsoleted version of platform-python in python3 master.

That would fix this problem for people doing f27 -> f28 upgrade. However, fixing this for rawhide users for a package that has already been removed would require reintroducing it again (which i think is not worth it for a non fatal warning).

Comment 6 Zbigniew Jędrzejewski-Szmek 2017-11-21 09:04:02 UTC
Igor, I think a mail to fedora-devel@ that summarizes the removal of platform-python is needed. Both to help people who are not directly involved stay abreast of changes, and as a postmortem for something that was introduced as a significant change.

Comment 7 Miro Hrončok 2017-11-21 09:33:19 UTC
platform-python f27 PR https://src.fedoraproject.org/rpms/platform-python/pull-request/1

Comment 8 Jan Pokorný [poki] 2017-11-21 10:04:52 UTC
re [comment 4]:

Nice catch, would not expect that being an issue (already hit some
strangeness that extra new-line was needed for macro to figure out its
boundary correctly, but this syntactical constraint is all new to me).

Modified summary to drop innocent ldconfig reference.


re [comment 5]:

I haven't articulated that, but the point of this bug was to make
transition smooth for stabilized distros upgrade, so agree there's
nothing particularly important as far as rawhide goes.


re [comment 2]:

> What do you think would be the best reference? Should I post an email
> to devel? Create a Fedora change proposal?

Any discoverable summary works for me (see the sources I checked prior
to complaining about the missing justification -- I have omitted
fedora-devel ML, which is, I believe, implicitly assumed as the main
stream of such updates, so agree with Zbigniew from [comment 6]).


Thanks!

Comment 9 Miro Hrončok 2017-11-21 10:07:06 UTC
python3 master PR https://src.fedoraproject.org/rpms/python3/pull-request/18

Comment 10 Tomas Orsava 2017-11-21 14:50:03 UTC
(In reply to Zbigniew Jędrzejewski-Szmek from comment #6)
> Igor, I think a mail to fedora-devel@ that summarizes the removal of
> platform-python is needed. Both to help people who are not directly involved
> stay abreast of changes, and as a postmortem for something that was
> introduced as a significant change.

I'll take care of the email.

Comment 12 Fedora Update System 2017-11-23 13:02:57 UTC
platform-python-3.6.2-13.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2017-41f1da221e

Comment 13 Fedora Update System 2017-11-25 00:36:20 UTC
platform-python-3.6.2-13.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-41f1da221e

Comment 14 Fedora Update System 2017-12-10 05:05:11 UTC
platform-python-3.6.2-13.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.